{
  inputs = {
    nixpkgs = {
      url = "github:NixOS/nixpkgs/release-23.05";
    };
    sops-nix = {
      url = "github:Mic92/sops-nix";
      # Follow the system nixpkgs
      inputs.nixpkgs.follows = "nixpkgs";
    };
    nix-matlab = {
      url = "gitlab:doronbehar/nix-matlab";
      # Follow the system nixpkgs
      inputs.nixpkgs.follows = "nixpkgs";
    };
  };
  outputs = { self, nixpkgs, sops-nix, nix-matlab }@attrs: let 
    system = "x86_64-linux";
    unfree-overlay = final: prev: {
      unfree = import nixpkgs {
        inherit system;
        config.allowUnfree = true;
      };
    };
    applyOverlays = overlays: ({...}:{ nixpkgs.overlays = overlays; });
  in {
    nixosConfigurations.kcnhub = nixpkgs.lib.nixosSystem {
      inherit system;
      specialArgs = attrs;
      modules = [ 
         (applyOverlays [ unfree-overlay ])
         ./machines/kcnhub/configuration.nix
         sops-nix.nixosModules.sops
      ];
    };
  };
}
